local IsUsingLS = false
local enableAutoDodgebolt = true
local firstHitFlag = true
local PlayerManager
local dmgOwnerType
local curPlayerIndex
local masterPlayer
local masterPlayerIndex
local masterPlayerBase
local mPlObj
local mPlBHVT -- via.behaviortree.BehaviorTree
local action_bank_id 
local action_id 
local frame_delay = 0

sdk.hook(sdk.find_type_definition("snow.player.PlayerMotionControl"):get_method("lateUpdate"),
function(args)
	local motionControl = sdk.to_managed_object(args[2])
	local refPlayerBase = motionControl:get_field("_RefPlayerBase")
	local curPlayerIndex = refPlayerBase:get_field("_PlayerIndex")
	
	if curPlayerIndex == masterPlayerIndex then
		action_id = motionControl:get_field("_OldMotionID")
		action_bank_id = motionControl:get_field("_OldBankID")
	end
end,
function(retval) end
)


re.on_frame(function()
	if not PlayerManager then
        PlayerManager = sdk.get_managed_singleton('snow.player.PlayerManager')
    end
	if not PlayerManager then return end
	masterPlayer = PlayerManager:call("findMasterPlayer")
	masterPlayerIndex = masterPlayer:get_field("_PlayerIndex")
	
	masterPlayerBase = PlayerManager:call("findMasterPlayer")
	if not masterPlayerBase then return end
	
	IsUsingLS = masterPlayerBase:get_field("_playerWeaponType") == 2
	mPlObj = masterPlayerBase:call("get_GameObject")
    mPlBHVT = mPlObj:call("getComponent(System.Type)",sdk.typeof("via.behaviortree.BehaviorTree"))
end)

sdk.hook(sdk.find_type_definition("snow.player.PlayerQuestBase"):get_method("checkCalcDamage_DamageSide"),
	function(args)
		local manager = sdk.to_managed_object(args[2])	
		local argManager = sdk.to_managed_object(args[3])
		local damageData = argManager:call("get_AttackData")
		
		dmgOwnerType = damageData:call("get_OwnerType")
		curPlayerIndex = manager:get_field("_PlayerIndex")
		masterPlayerIndex = masterPlayerBase:get_field("_PlayerIndex")
	end,
    function(retval)
		local dmgFlowType = sdk.to_int64(retval)
		if IsUsingLS and curPlayerIndex == masterPlayerIndex and dmgOwnerType == 1 and dmgFlowType == 0 then
			if firstHitFlag then
				if action_bank_id == 100 then
					if (action_id >105 and  action_id < 113) or (action_id > 313 and action_id < 320) or action_id == 321 or action_id == 301 then
						mPlBHVT:call("setCurrentNode(System.UInt64, System.UInt32, via.behaviortree.SetNodeInfo)",2324039990,nil,nil)
						firstHitFlag = false
						return sdk.to_ptr(1)
					end
				end	
			elseif action_bank_id ~= 100 then
				firstHitFlag = true
				return retval
			elseif (action_id < 105 or  action_id > 113) and (action_id < 313 or action_id > 320) and action_id ~= 321 and action_id ~= 301 then
				firstHitFlag = true
				return retval
			end
			firstHitFlag = true
			return retval

		end		
		return retval
	end
)

-- draw ui
re.on_draw_ui(
function()
    local changed
	changed, enableAutoDodgebolt = imgui.checkbox("Auto KonKijin",enableAutoDodgebolt)	
end)

-- 2692283689 Dodgebolt lever check node id
-- 1704832922 escape_back